#include <cstdio>
#include <cmath>
#include <list>


struct list
{
  long long x;
  list *Next, *Prev;
};

class LIST
{
  list *begin;
  list *end;
public:
  LIST ()
  {
  }
  void push_front(long long x)
  {
    if (begin == nullptr)
    {
      list *l = new list;
      l->x = x;
      l->Next = l->Prev = nullptr;
      begin = end = l;
    }
    else
    {
      list *l = new list;
      l->x = x;
      l->Next = begin;
      l->Prev = nullptr;
      begin->Prev = l;
      begin = l;
    }
  }
  void pop_back()
  {
    if (begin == nullptr)
    {
    }
    else
    {
      if (end->Prev == nullptr)
        {
          delete end;
          begin = end = nullptr;
      }
      else
      {
        list * tmp = end;
        end = end->Prev;
        end->Next = nullptr;
        delete tmp;
      }
    }
  }
  long long get()
  {
    return end->x;
  }
  
  long long gett(long long a)
  {
    list *l = begin;
    for (long long i = 0; i < a; i++)
      l = l->Next;
    return l->x;
  }
  
  
  void insert(long long pos, long long x)
  {
    list *l = begin;
    for (long long i = 0; i < pos; i++)
      l = l->Next;
    
    list *l2 = new list;
    l2->x = x;
    l2->Next = l;
    l2->Prev = l->Prev;
    if (l2->Prev != nullptr)
      l2->Prev->Next = l2;
    else
      begin = l2;
    if (l2->Next != nullptr)
      l2->Next->Prev = l2;
    else
      end = l2;
  }
};

int main( void )
{
  long long n, m;
  long long s = 0, k = 0;

  scanf("%lld %lld", &n, &m);


  long long *Door = new long long [m];
  long long *Ans = new long long [m * m];

  LIST Key;

  for (long long i = 0; i < m; i++)
    scanf("%lld", Door + i);

  long long tmp;

  for (long long i = 0; i < n; i++)
  {
    scanf("%lld", &tmp);
    Key.push_front(tmp);
  }
    if (Door[0] == Key.get())
  {
  printf("%lld\n", m);

  for (long long i = 0; i < m; i++)
    printf("%lld ", m);
  }
  else
  {
  printf("%lld\n", m + m - 1);
  
  for (long long i = m; i > 1; i--)
    printf("%lld ", i);
  for (long long i = 0; i < m; i++)
    printf("%lld ", m);
  }
  while (k != m)
  {
    //if (Key.get() == Door[k])
      k++;

    long long i = k;
    while (i < m && Key.get() != Door[i])
      i++;

    long long p = n;
    long long pos = 0;
    int f = 1;

    while (f && pos != n)
    {
      for (long long h = i - 1; h >= k; h--)
        if (Key.gett(pos) == Door[h])
        {
          f = 0;
          Key.insert(pos, Key.get());
          Key.pop_back();
          Ans[s] = p;
          break;
        }

      if (f)
        pos++;
      p--;
    }
    if (f)
    {
      Ans[s] = 1;
    }
    s++;
  }


  //printf("%lld\n", s);

  //for (long long i = 0; i < s; i++)
  //  printf("%lld ", Ans[i]);
  return 0;
}

//4 5 4 1 2 4 4 4 3 2 1